﻿using System;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace AsyncDemoWinForm
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        #region Do things
        public long DoSomething(int n)
        {
            long result = 1;
            for (int i = 1; i <= n; i++)
            {
                result += i;
            }
            return result;
        }
        #endregion

        #region Sync
        private void btnSync_Click(object sender, EventArgs e)
        {
            lblResult.Text = "Start to do something...";
            long value = DoSomething(int.MaxValue / 2);
            lblResult.Text = value.ToString();
        }
        #endregion

        #region Callback
        private void btnCallback_Click(object sender, EventArgs e)
        {
            lblResult.Text = "Start to do something . . .";
            Func<int, long> callBackDelegate = this.DoSomething;
            callBackDelegate.BeginInvoke(
                int.MaxValue / 2,
                new AsyncCallback(
                a =>
                {
                    lblResult.Invoke(new MethodInvoker(() =>
                        {
                            lblResult.Text = callBackDelegate.EndInvoke(a).ToString();
                        }));
                }),
                null);
        }
        #endregion

        #region Asyn
        public Task<long> DoSomethingAsync(int n)
        {
            return TaskEx.Run<long>(() => DoSomething(n));
        }

        private async void btnAsync_Click(object sender, EventArgs e)
        {
            lblResult.Text = "Start do something...";
            var x = await DoSomethingAsync(int.MaxValue / 2);
            lblResult.Text = x.ToString();
        }
        #endregion
    }
}
